/**
* @file    MAIN.cpp
* @author  Thales Vieira <thalesv@gmail.com>
* @author  Instituto de Matemtica, UFAL
* @version 0.1
* @date    12/04/2010
*
* @brief   Esqueleto de programa usando a GLUT para
* @brief   o curso de Computao Grfica Interativa
* @brief   Aula 9
*/
//________________________________________________

#include <windows.h>
#include <iostream>
#include <glut.h>

#include <math.h>

#define PI 3.141592653589793238462643

//incluses de bibliotecas para o vector
#include <vector>
using namespace std;

//estruturas de ponto e triangulo 3D
typedef struct {
	float x;
	float y;
	float z;
} ponto3D;

typedef struct {
	ponto3D p1;
	ponto3D p2;
	ponto3D p3;
} Triangulo3D;

//vetor de triangulos 3D
vector<Triangulo3D> triangulos;


void DesenhaTriangulo(Triangulo3D t)
{
   glColor3f(1.0,0.0,0.0);
	glBegin(GL_TRIANGLES); 
		glVertex3f(t.p1.x,t.p1.y,t.p1.z);
		glVertex3f(t.p2.x,t.p2.y,t.p2.z);
		glVertex3f(t.p3.x,t.p3.y,t.p3.z);
	glEnd();
	
   glColor3f(0.0,0.0,0.0);
	glBegin(GL_LINE_LOOP); 
		glVertex3f(t.p1.x,t.p1.y,t.p1.z);
		glVertex3f(t.p2.x,t.p2.y,t.p2.z);
		glVertex3f(t.p3.x,t.p3.y,t.p3.z);
	glEnd();
	
}

void display() {

   glClearColor(1.0, 1.0, 1.0, 0.0);
   glClear(GL_COLOR_BUFFER_BIT);

   glLoadIdentity();
   glLineWidth(2);
   
   //desenha todos os triangulos contidos no vector de triangulos
   for(int i=0;i<triangulos.size();++i)
	   DesenhaTriangulo(triangulos[i]);


   glutSwapBuffers(); //Atualiza o BUFFER
}

/***
* init():
*   Configura o OpenGL.
*   Configuramos a matriz de 
*   projeo ortogonal ortogonal, neste caso.
***/
void init() {
   glMatrixMode(GL_PROJECTION);   
	glLoadIdentity();
	gluPerspective(45.f,1.0,0.001,100.);
   glMatrixMode(GL_MODELVIEW);
}

/***
* main():
*    Esta  a funo que  chamada quando executamos o programa. Vamos inicializar janelas
e configurar o GLUT aqui.
***/
int main(int argc, char** argv) 
{

	ponto3D p1,p2,p3,p4;
	
	p1.x=-0.1;
	p1.y=-0.13;
	p1.z=-0.3;

	p2.x=0.2;
	p2.y=-0.1;
	p2.z=-0.8;

	p3.x=-0.12;
	p3.y=0.2;
	p3.z=-0.5;

	p4.x=1.11;
	p4.y=0.0;
	p4.z=-0.3;

	Triangulo3D t1,t2;
	
	t1.p1=p1;
	t1.p2=p2;
	t1.p3=p3;

	t2.p1=p2;
	t2.p2=p3;
	t2.p3=p4;

	triangulos.push_back(t1);
	triangulos.push_back(t2);


   // Inicializa o ambiente do GLUT
   glutInit(&argc, argv);

   // Configuraes de janela e de sistema de cor.
   glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutInitWindowSize(250,250);
   glutInitWindowPosition(100,100);

   // Cria a janela do GLUT com o ttulo "Hello World!"
   glutCreateWindow("Hello World!");

   // Determina qual funo deve ser chamada para desenhar na tela (draw)
   glutDisplayFunc(display);

   // Esta funo inicializa configuraes do OpenGL
   init();

   // Exibe a janela e desenha na tela, usando a funo determinada em glutDisplayFunc
   glutMainLoop();
   return 0;
}