/**
* @file    MAIN.cpp
* @author  Thales Vieira <thalesv@gmail.com>
* @author  Instituto de Matemtica, UFAL
* @version 0.1
* @date    12/04/2010
*
* @brief   Esqueleto de programa usando a GLUT para
* @brief   o curso de Computao Grfica Interativa
* @brief   Aula 9
*/
//________________________________________________

#include <windows.h>
#include <iostream>
#include <glut.h>

#include <math.h>

#define PI 3.141592653589793238462643


void display() {

   glClearColor(1.0, 1.0, 1.0, 0.0);
   glClear(GL_COLOR_BUFFER_BIT);
	
   glPushMatrix();
   glLoadIdentity();
   glLineWidth(2);

   glColor3f(1.0,1.0,0.0);

   gluLookAt(10.0,0.0,10.0,-1.0,0.0,-1.0,0.0,0.0,1.0);
   
   glBegin(GL_LINE_STRIP);
   for(float t=0.0;t<=16*PI;t+=0.01)
	 glVertex3f(cos(t),sin(t),t);
   glEnd();
   glPopMatrix();

   glutSwapBuffers(); //Atualiza o BUFFER
}

/***
* init():
*   Configura o OpenGL.
*   Configuramos a matriz de 
*   projeo ortogonal ortogonal, neste caso.
***/
void init() {
   glMatrixMode(GL_PROJECTION);   
	glLoadIdentity();
	gluPerspective(45.f,1.0,0.001,100.);
//	glOrtho(-2.0,2.0,-2.0,2.0,-10.0,10.0);
   glMatrixMode(GL_MODELVIEW);
}

/***
* main():
*    Esta  a funo que  chamada quando executamos o programa. Vamos inicializar janelas
e configurar o GLUT aqui.
***/
int main(int argc, char** argv) 
{
   // Inicializa o ambiente do GLUT
   glutInit(&argc, argv);

   // Configuraes de janela e de sistema de cor.
   glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutInitWindowSize(250,250);
   glutInitWindowPosition(100,100);

   // Cria a janela do GLUT com o ttulo "Hello World!"
   glutCreateWindow("Hello World!");

   // Determina qual funo deve ser chamada para desenhar na tela (draw)
   glutDisplayFunc(display);

   // Esta funo inicializa configuraes do OpenGL
   init();

   // Exibe a janela e desenha na tela, usando a funo determinada em glutDisplayFunc
   glutMainLoop();
   return 0;
}